Subject: Re: [RFC PATCH 3/4] net: Store checksum result for offloaded GSO checksums

From: Edward Cree <[email-masked]>
Date: Thu, 14 Jan 2016 12:02:33 +0000

On 14/01/16 05:12, Alexander Duyck wrote:
> In order to do that I replaced CHECKSUM_PARTIAL with
> CHECKSUM_UNNECESSARY in the case of us computing checksums for the outer
> header while skipping computing checksums for the inner headers.  We clean
> up the ip_summed flag and set it to either CHECKSUM_PARTIAL or
> CHECKSUM_NONE once we hand the packet off to the next lower level.
I feel like this should probably be mentioned in the comment at thetop of
 skbuff.h.  I think section E of that comment will need to be more or less
 completely re-written with this patch series.  In particular, if I'm
 understandingcorrectly, csum_start and csum_offset will point to the
 inner checksum (unless using RCO), same as they do without GSO.  And GSO
 will never offload multiple checksums (although TSO will still have to
 _edit_ multiple checksums).
Or better still, proper documentation of GSO and TSO would be nice :)